# Alibris scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")

    # Get detail page if necessary
    i = string.find(source, "<!--LIST START-->")

    if i != -1:
        source = searchForPlus(source, "<!--LIST START-->")
        source = searchForPlus(source, "<a href=\"")
        i = string.find(source, "\"")
        url = "http://www.alibris.com" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    # Main extraction
    # Find Image
    i = string.find(source, "<img itemprop=\"image\"")

    if i != -1:
        image = searchForPlus(source, "<img itemprop=\"image\"")
        image = searchForPlus(image, " src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        rw.setImage1(image)


    # Find price
    i = string.find(source, "class=\"item-add-cart\"")

    if i != -1:
        value = searchForPlus(source, "class=\"item-add-cart\"")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Title
    title = searchForPlus(source, "class=\"product-title\"")
    title = searchForPlus(title, "itemprop=\"name\"")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    if title[len(title)-1:] == ".":
        title = stripText(title[0:len(title)-1])

    rw.setTitle(title)


    # Find Author
    authorList = []
    i = string.find(source, "<h2>by")

    if i != -1:
        authors = searchForPlus(source, "<h2>by")
        i = string.find(authors, "</h2>")
        authors = stripText(authors[0:i])

        while (searchFor(authors, "itemprop=\"author\"") != None):
            authors = searchForPlus(authors, "itemprop=\"author\"")
            author = searchForPlus(authors, "itemprop=\"name\"")
            author = searchForPlus(author, ">")
            i = string.find(author, "<")
            author = stripText(author[0:i])
            authorList.append(author)

        rw.setAuthors(authorList)


    # Find Product Info
    i = string.find(source, "class=\"synopsis\" id=\"synopsis-detail\"")

    if i != -1:
        comments = searchForPlus(source, "class=\"synopsis\" id=\"synopsis-detail\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</p>")
        comments = stripText(comments[0:i])
        i = string.find(comments, "<a href=\"javascript:void(0);\"")

        if i != -1:
            comments = stripText(comments[0:i])

        rw.setProductInfo(comments)


    # Find Format
    i = string.find(source, "class=\"isbn-link\"")

    if i != -1:
        format = searchForPlus(source, "class=\"isbn-link\"")
        format = searchForPlus(format, "<p>")
        i = string.find(format, "<")
        format = stripText(format[0:i])

        i = string.find(format, ",")

        if i != -1:
            format = stripText(format[0:i])

        rw.setFormat(format)


    # Find Publisher
    i = string.find(source, "class=\"date-publisher\"")

    if i != -1:
        publisher = searchForPlus(source, "class=\"date-publisher\"")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])

        i = string.find(publisher, ", ")

        if i != -1:
            publisher = stripText(publisher[i+1:])
        
        rw.setPublisher(publisher)


    # Find Published date
    i = string.find(source, "class=\"date-publisher\"")

    if i != -1:
        date = searchForPlus(source, "class=\"date-publisher\"")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        i = string.find(date, ", ")

        if i != -1:
            date = stripText(date[0:i])

        rw.setReleaseDate(date)


    # Find ISBN
    i = string.find(source, "class=\"isbn-link\"")

    if i != -1:
        isbn = searchForPlus(source, "class=\"isbn-link\"")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Category
    i = string.find(source, "class=\"breadcrumb-genre clearfix\"")

    if i != -1:
        cats = searchForPlus(source, "class=\"breadcrumb-genre clearfix\"")
        cats = searchForPlus(cats, "<ul")
        cats = searchForPlus(cats, "</li>")
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "<li>") != None):
            cats = searchForPlus(cats, "<li>")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Books":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
