# amazon.de scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    rw.setCurrencySymbol("")
    rw.setPublicationPlace("Germany")
    rw.setLanguage("German")

    if source.startswith("<HTML><BODY><B>ERROR - URL: ") == 1:
        # Special characters in URL, translate and try again
    	source = searchForPlus(source, "<HTML><BODY><B>ERROR - URL: ")
        i = string.find(source, " ")
        source = stripText(source[0:i])
        source = replaceURL(source)
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(source, "UTF-8")
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    tag = "class=resultCount"

    if string.find(source, tag) == -1:
        tag = "id=\"result_0\""

    if string.find(source, tag) == -1:
        tag = "class=\"searchresults\""

    i = string.find(source, tag)

    if i != -1:
        # Amazon search results page, follow link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        source = stripText(source[0:i])
        http = HTTPConnection()
        
        try:
            http.setGenericUserAgent()
        except:
            print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(source, "UTF-8")
        t = open(rw.getLogsDir() + "trace2.html", "w")
        t.write(source)
        t.close()

        i = string.find(source, "\"btAsinTitle\"")

        if i != -1:
            print "OLD FORMAT"
            extractOld(source)
            return


    # If Amazon lists other editions, remove them.
    # complicates price extraction
    i = string.find(source, ">Weitere Ausgaben")

    if i != -1:
        j = string.find(source[i:], "</table")
        source = source[0:i+1] + source[i+j:]

    i = string.find(source, "td.otherEditions")

    if i != -1:
        j = string.find(source[i:], "</table")
        source = source[0:i+1] + source[i+j:]


    # Find Image
    tag = "id='imageBlock'"
    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"imageBlock\""
        i = string.find(source, tag)

    if i == -1:
        tag = "id=\"ebooks-img-canvas\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "data:")

        if i != -1:
            image = ""

        i = string.find(image, "no-img")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)

    if rw.getImage1() == None:
        tag = "'imageGalleryData'"
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(source, "mainUrl\":\"")

            if i != -1:
                images = searchForPlus(images, "mainUrl\":\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                rw.setImage1(image)
                rw.setLargeImage1(image)


    # Find new price/count
    i = string.find(source, "dp_olp_new")

    if i != -1:
        new = searchForPlus(source, "dp_olp_new")
        new = searchForPlus(new, "condition=new")
        new = searchForPlus(new, ">")
        new = stripText(new)
        i = string.find(new, "&nbsp;")
        newc = stripText(new[0:i])

        i = string.find(newc, " ")

        if i != -1:
            newc = stripText(newc[0:i])

        rw.setNewCount(newc)

        if rw.getNewCount() != "0":
            new = searchForPlus(new, "EUR")
            i = string.find(new, "<")
            rw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "ref=dp_olp_used")

    if i != -1:
        used = searchForPlus(source, "ref=dp_olp_used")
        used = searchForPlus(used, "condition=used")
        used = searchForPlus(used, ">")
        used = stripText(used)
        i = string.find(used, "&nbsp;")
        usedc = stripText(used[0:i])

        i = string.find(usedc, " ")

        if i != -1:
            usedc = stripText(usedc[0:i])

        rw.setUsedCount(usedc)

        if rw.getUsedCount() != "0":
            used = searchForPlus(used, "EUR")
            i = string.find(used, "<")
            rw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "olp-collectible olp-link")

    if i != -1:
        col = searchForPlus(source, "olp-collectible olp-link")
        col = searchForPlus(col, "condition=collectible")
        col = searchForPlus(col, ">")
        col = stripText(col)
        i = string.find(col, "&nbsp;")
        colc = stripText(col[0:i])

        i = string.find(colc, " ")

        if i != -1:
            colc = stripText(colc[0:i])

        rw.setCollectibleCount(colc)

        if rw.getCollectibleCount() != "0":
            col = searchForPlus(col, "EUR")
            i = string.find(col, "<")
            rw.setCollectiblePrice(col[0:i])


    # Find Price
    i = string.find(source, "id=\"buyNewSection\"")

    if i != -1:
        value = searchForPlus(source,  "id=\"buyNewSection\"")
        value = searchForPlus(value,  "EUR ")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Title
    tag = "id='title'"

    if string.find(source, tag) == -1:
        tag = "<h1 id=\"title\""

    source = searchForPlus(source, tag)
    tag = "id=\"productTitle\""

    if string.find(source, tag) == -1:
        tag = "id=\"ebooksProductTitle\""

    source = searchForPlus(source, tag)
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    rw.setTitle(title)


    # Find Author
    authorList = []
    tag = "contributorNameID"

    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"author notFaded\""
        i = string.find(source, tag)

    if i != -1:
        source = searchFor(source, tag)

        i = string.find(source, "</span>")
        authors = stripText(source[0:i])
        authorList = []

        while (searchFor(authors, "href=\"") != None):
            authors = searchForPlus(authors, "href=\"")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.find(authors, "class=\"byLinePipe\">")

            if i != -1:
                authors = searchForPlus(authors, "class=\"byLinePipe\">")
                authors = stripText(authors)

                if authors.startswith("(") == 1:
                    i = string.find(authors, ")")
                    role = stripText(authors[0:i+1])

                    if role == "(Illustrator)":
                        rw.setIllustrator(author)
                        author = ""
                    elif role == "(bersetzer)":
                        rw.setTranslator(author)
                        author = ""
                    elif role == "(Editor)":
                        rw.setEditor(author)
                        author = ""
                
            if author != "":
                author =  string.replace(author, "\303\274", "")
                authorList.append(author)

        rw.setAuthors(authorList)


    # find listprice
    i = string.find(source,"Preisempfehlung&#42;:&#160;<")

    if i != -1:
    	source = searchForPlus(source,"Preisempfehlung&#42;:&#160;<")
    	source = searchForPlus(source,">")
    	i = string.find(source,"<")
    	listprice = stripText(source[0:i])
        rw.setListPrice(listprice)


    # Find Attributes
    attrtag = ">Produktinformation<"
    i = string.find(source, attrtag)

    if i != -1:
        attributes = searchFor(source, attrtag)
        i = string.find(attributes, "</ul>")
        attributes = stripText(attributes[0:i])

        # Find Format
        format = searchForPlus(attributes, "<b>")

        if format.startswith("Format") == 1:
            format = searchForPlus(format, ">")

        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, ":")

        if i != -1:
            format = stripText(format[0:i])

        rw.setFormat(format)


        # Find Pages
        attributes = searchForPlus(attributes, "<b>")
        i = string.find(attributes, "Seiten<")

        if (i != -1):
            attributes = stripText(attributes[i-10:])
            attributes = stripText(searchForPlus(attributes, ">"))

            i = string.find(attributes, " ")

            if (i != -1):
                pages = stripText(attributes[0:i])

                i = string.find(pages, " ")

                if (i != -1):
                    pages = stripText(pages[0:i])

                rw.setPages(pages)


        # Find Publication Date
        date = searchForPlus(attributes, "(")
        i = string.find(date, ")")
        date = stripText(date[0:i])

        # [Haai]
        # sometimes there is no date supplied, and the scraper hits the
        # bracket of Category(ies), giving date ies
        if date[0:3] == "ies":
            date = ""

        date = string.replace(date, "Juli", "July")
        date =  string.replace(date, "\303\244", "")
        rw.setReleaseDate(date)


        # Find Language
        language = searchForPlus(attributes, ">Sprache:")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        language = stripText(language[0:i])
        rw.setLanguage(language)


        # Find Publisher
        i = string.find(attributes, ">Verlag:<")

        if i != -1:
            publisher = searchForPlus(attributes, ">Verlag:<")
            publisher = searchForPlus(publisher, ">")
            i = string.find(publisher, "<")
            publisher = stripText(publisher[0:i])
            publisher = string.replace(publisher, "&amp;", "&")
            publisher =  string.replace(publisher, "\303\274", "")

            i = string.find(publisher, ";")

            if i != -1:
                publisher = stripText(publisher[0:i])

            i = string.find(publisher, "(")

            if i != -1:
                publisher = stripText(publisher[0:i])

            rw.setPublisher(publisher)

        # Find ISBN
        i = string.find(attributes, "ISBN-10:")

        if (i != -1):
            isbn = searchForPlus(attributes, "ISBN-10:")
            isbn = searchForPlus(isbn, ">")
            i = string.find(isbn, "<")
            isbn = stripText(isbn[0:i])
            i = string.find(isbn, " ")

            if i != -1:
                isbn = stripText(isbn[0:i])

            rw.setISBN(isbn)

        # Find ASIN
        i = string.find(attributes, ">ASIN:<")

        if (i != -1):
            isbn = searchForPlus(attributes, ">ASIN:<")
            isbn = searchForPlus(isbn, ">")
            i = string.find(isbn, "<")
            isbn = stripText(isbn[0:i])
            i = string.find(isbn, " ")

            if i != -1:
                isbn = stripText(isbn[0:i])

            rw.setASIN(isbn)


        # sales ranking
        i = string.find(attributes, ">Amazon.de Verkaufsrang:<")

        if i != -1:
            salesrank = searchForPlus(attributes,">Amazon.de Verkaufsrang:<")
            salesrank = searchForPlus(salesrank,">")
            i = string.find(salesrank,"<")
            salesrank = stripText(salesrank[0:i])

            if salesrank.startswith("#") == 1:
                salesrank = searchForPlus(salesrank, "#")

            i = string.find(salesrank, " ")

            if i != -1:
                salesrank = stripText(salesrank[0:i])

            rw.setSalesRank(salesrank)
    		

    # Find Comments
    comments = ""
    tag = "id=\"bookDesc_override_CSS\""
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<noscript>")
        i = string.find(comments, "</noscript>")
        comments = stripText(comments[0:i])
        rw.setProductInfo(comments)

    tag = ">Kurzbeschreibung"
    i = string.find(source, tag)

    if i != -1:
        tempcomments = searchForPlus(source, tag)
        tempcomments = searchForPlus(tempcomments, "<div")
        tempcomments = searchForPlus(tempcomments, ">")
        i = string.find(tempcomments, "<div ")
        comments = tempcomments[0:i]
    
        rw.setProductInfo(comments)

    tag = ">Produktbeschreibung"
    i = string.find(source, tag)

    if i != -1:
        tempcomments = searchForPlus(source, tag)
        tempcomments = searchForPlus(tempcomments, "<div")
        tempcomments = searchForPlus(tempcomments, ">")
        i = string.find(tempcomments, "<div id=")
        tempcomments = tempcomments[0:i]

        i = string.find(tempcomments, "<script")

        if i != -1:
            tempcomments = tempcomments[0:i]
    
        if comments == "":
            rw.setProductInfo(tempcomments)
        else:
            comments = appendComment(comments, tempcomments)
            rw.setProductInfo(comments)




def extractOld(source):
    rw.setCurrencySymbol("")
    rw.setPublicationPlace("Germany")
    rw.setLanguage("German")

    if source.startswith("<HTML><BODY><B>ERROR - URL: ") == 1:
        # Special characters in URL, translate and try again
    	source = searchForPlus(source, "<HTML><BODY><B>ERROR - URL: ")
        i = string.find(source, " ")
        source = stripText(source[0:i])
        source = replaceURL(source)
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(source)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    tag = "class=resultCount"

    if string.find(source, tag) == -1:
        tag = "id=\"result_0\""

    if string.find(source, tag) == -1:
        tag = "class=\"searchresults\""

    i = string.find(source, tag)

    if i != -1:
        # Amazon search results page, follow link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        source = stripText(source[0:i])
        http = HTTPConnection()
        
        try:
            http.setGenericUserAgent()
        except:
            print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(source)
        t = open(rw.getLogsDir() + "trace2.html", "w")
        t.write(source)
        t.close()


    # If Amazon lists other editions, remove them.
    # complicates price extraction
    i = string.find(source, ">Weitere Ausgaben")

    if i != -1:
        j = string.find(source[i:], "</table")
        source = source[0:i+1] + source[i+j:]

    i = string.find(source, "td.otherEditions")

    if i != -1:
        j = string.find(source[i:], "</table")
        source = source[0:i+1] + source[i+j:]


    # Find Image (first try)
    image = ""
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        images = searchForPlus(source, "registerImage(\"original_image\"")
        images = searchForPlus(images, "\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)
            else:
                rw.setImage1(image)


    # Find Image
    tag = "id=\"main_image_0\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)


    # Find new price/count
    i = string.find(source, "dp_olp_new")

    if i != -1:
        new = searchForPlus(source, "dp_olp_new")
        new = searchForPlus(new, "&condition=new")
        new = searchForPlus(new, ">")
        new = stripText(new)
        i = string.find(new, "&nbsp;")
        rw.setNewCount(new[0:i])

        if rw.getNewCount() != "0":
            new = searchForPlus(new, "EUR")
            i = string.find(new, "<")
            rw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "ref=dp_olp_used")

    if i != -1:
        used = searchForPlus(source, "ref=dp_olp_used")
        used = searchForPlus(used, "&condition=used")
        used = searchForPlus(used, ">")
        used = stripText(used)
        i = string.find(used, "&nbsp;")
        rw.setUsedCount(used[0:i])

        if rw.getUsedCount() != "0":
            used = searchForPlus(used, "EUR")
            i = string.find(used, "<")
            rw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "olp-collectible olp-link")

    if i != -1:
        col = searchForPlus(source, "olp-collectible olp-link")
        col = searchForPlus(col, "&amp;condition=collectible")
        col = searchForPlus(col, ">")
        col = stripText(col)
        i = string.find(col, "&nbsp;")
        rw.setCollectibleCount(col[0:i])

        if rw.getCollectibleCount() != "0":
            col = searchForPlus(col, "EUR")
            i = string.find(col, "<")
            rw.setCollectiblePrice(col[0:i])


    # Find Title
    source = searchForPlus(source, "\"btAsinTitle\"")
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])
    rw.setTitle(title)


    # Find Author
    authorList = []
    tag = "href=\""

    i = string.find(source, tag)

    if i != -1 and i <= 2500:
        source = searchFor(source, tag)

        i = string.find(source, "\n")
        authors = stripText(source[0:i])
        authorList = []

        while (searchFor(authors, tag) != None):
            authors = searchForPlus(authors, tag)
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.find(authors, "class=\"byLinePipe\">")

            if i != -1:
                authors = searchForPlus(authors, "class=\"byLinePipe\">")
                authors = stripText(authors)

                if authors.startswith("(") == 1:
                    i = string.find(authors, ")")
                    role = stripText(authors[0:i+1])

                    if role == "(Illustrator)":
                        rw.setIllustrator(author)
                        author = ""
                    elif role == "(bersetzer)":
                        rw.setTranslator(author)
                        author = ""
                    elif role == "(Editor)":
                        rw.setEditor(author)
                        author = ""
                
            if author != "":
                authorList.append(author)

        rw.setAuthors(authorList)


    # find listprice
    i = string.find(source,"Preisempfehlung&#42;:&#160;<")

    if i != -1:
    	source = searchForPlus(source,"Preisempfehlung&#42;:&#160;<")
    	source = searchForPlus(source,">")
    	i = string.find(source,"<")
    	listprice = stripText(source[0:i])
        rw.setListPrice(listprice)

    # Find Price
    i = string.find(source, "Preis:<")

    if (i != -1):
        source = searchForPlus(source, "Preis:<")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        rw.setItemValue(value)

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Attributes
    attrtag = ">Produktinformation<"
    i = string.find(source, attrtag)

    if i != -1:
        attributes = searchFor(source, attrtag)
        i = string.find(attributes, "</ul>")
        attributes = stripText(attributes[0:i])

        # Find Format
        format = searchForPlus(attributes, "<b>")

        if format.startswith("Format:") == 1:
            format = searchForPlus(format, ">")

        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, ":")

        if i != -1:
            format = stripText(format[0:i])

        rw.setFormat(format)


        # Find Pages
        attributes = searchForPlus(attributes, "<b>")
        i = string.find(attributes, "Seiten")

        if (i != -1):
            attributes = stripText(attributes[i-10:])
            attributes = stripText(searchForPlus(attributes, ">"))

            i = string.find(attributes, " ")

            if (i != -1):
                pages = stripText(attributes[0:i])

                i = string.find(pages, " ")

                if (i != -1):
                    pages = stripText(pages[0:i])

                rw.setPages(pages)


        # Find Publication Date
        date = searchForPlus(attributes, "(")
        i = string.find(date, ")")
        date = stripText(date[0:i])

        # [Haai]
        # sometimes there is no date supplied, and the scraper hits the
        # bracket of Category(ies), giving date ies
        if date[0:3] == "ies":
            date = ""

        date = string.replace(date, "Juli", "July")
        rw.setReleaseDate(date)


        # Find Language
        language = searchForPlus(attributes, ">Sprache:")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        language = stripText(language[0:i])
        rw.setLanguage(language)


        # Find Publisher
        i = string.find(attributes, ">Verlag:<")

        if i != -1:
            publisher = searchForPlus(attributes, ">Verlag:<")
            publisher = searchForPlus(publisher, ">")
            i = string.find(publisher, "<")
            publisher = stripText(publisher[0:i])
            publisher = string.replace(publisher, "&amp;", "&")

            i = string.find(publisher, ";")

            if i != -1:
                publisher = stripText(publisher[0:i])

            i = string.find(publisher, "(")

            if i != -1:
                publisher = stripText(publisher[0:i])

            rw.setPublisher(publisher)

        # Find ISBN
        i = string.find(attributes, "ISBN-10:")

        if (i != -1):
            isbn = searchForPlus(attributes, "ISBN-10:")
            isbn = searchForPlus(isbn, ">")
            i = string.find(isbn, "<")
            isbn = stripText(isbn[0:i])
            i = string.find(isbn, " ")

            if i != -1:
                isbn = stripText(isbn[0:i])

            rw.setISBN(isbn)


        # sales ranking
        i = string.find(attributes, ">Amazon.de Verkaufsrang:<")

        if i != -1:
            salesrank = searchForPlus(attributes,">Amazon.de Verkaufsrang:<")
            salesrank = searchForPlus(salesrank,">")
            i = string.find(salesrank,"<")
            salesrank = stripText(salesrank[0:i])

            if salesrank.startswith("#") == 1:
                salesrank = searchForPlus(salesrank, "#")

            i = string.find(salesrank, " ")

            if i != -1:
                salesrank = stripText(salesrank[0:i])

            rw.setSalesRank(salesrank)
    		

    # Find Comments
    comments = ""

    tag = ">Kurzbeschreibung"
    i = string.find(source, tag)

    if i != -1:
        tempcomments = searchForPlus(source, tag)
        tempcomments = searchForPlus(tempcomments, "<div")
        tempcomments = searchForPlus(tempcomments, ">")
        i = string.find(tempcomments, "</div>")
        comments = tempcomments[0:i]
        comments =  string.replace(comments, "&#xe4;", "")
        comments =  string.replace(comments, "&#xfc;", "")
        comments =  string.replace(comments, "&#xdf;", "")
        comments =  string.replace(comments, "&#xf6;", "")
    
        rw.setProductInfo(comments)

    tag = ">Produktbeschreibung"
    i = string.find(source, tag)

    if i != -1:
        tempcomments = searchForPlus(source, tag)
        tempcomments = searchForPlus(tempcomments, "<div")
        tempcomments = searchForPlus(tempcomments, ">")
        i = string.find(tempcomments, "<div id=")
        tempcomments = tempcomments[0:i]

        i = string.find(tempcomments, "<script")

        if i != -1:
            tempcomments = tempcomments[0:i]

        tempcomments =  string.replace(tempcomments, "&#xe4;", "")
        tempcomments =  string.replace(tempcomments, "&#xfc;", "")
        tempcomments =  string.replace(tempcomments, "&#xdf;", "")
        tempcomments =  string.replace(tempcomments, "&#xf6;", "")
    
        if comments == "":
            rw.setProductInfo(tempcomments)
        else:
            comments = appendComment(comments, tempcomments)
            rw.setProductInfo(comments)

try:
    rw.setBookObject(Book)

    i = string.find(source, "\"btAsinTitle\"")

    if i == -1:
        # New format
        print "NEW FORMAT"
        extract(source)
    else:
        print "OLD FORMAT"
        extractOld(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
