# bibsys.no scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("Norway")


    i = string.find(source, "id=\"exlidResultsTable\"")

    if i != -1:
        source = searchForPlus(source, "id=\"exlidResultsTable\"")
        source = searchForPlus(source, "&amp;doc=")
        i = string.find(source, "&amp;")
        bid = stripText(source[0:i])
        url = "http://bibsys-almaprimo.hosted.exlibrisgroup.com/primo_library/libweb/action/display.do?tabs=detailsTab&ct=display&fn=search&doc={0}&indx=1&recIds={1}&recIdxs=0&elementId=0&renderMode=poppedOut&displayMode=full&frbrVersion=&frbg=&&dscnt=0&scp.scps=scope%3A%28BIBSYS_ILS%29%2Cscope%3A%28SC_OPEN_ACCESS%29%2Cscope%3A%28%22BIBSYS%22%29%2Cprimo_central_multiple_fe&mode=Basic&vid=BIBSYS&srt=rank&tab=default_tab"
        url = string.replace(url, "{0}", bid)
        url = string.replace(url, "{1}", bid)
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url, "UTF-8")
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    # Main extraction
    titleTag = ">Title:<"
    authorTag = ">Author:<"
    seriesTag = ">In series:<"
    dateTag = ">Year:<"
    pubTag = ">Printed:<"
    isbnTag = ">ISBN:<"
    pagesTag = ">Pages:<"
    langTag = "Sprk:"
    deweyTag = "Dewey:"
    keywordsTag = ">Subjects:<"
    descTag = "Beskrivelse:"

    i = string.find(source, titleTag)

    if i == -1:
        titleTag = ">Tittel:<"
        authorTag = ">Forfatter:<"
        seriesTag = ">I serie:<"
        dateTag = "rstall:"
        pubTag = "Utgiver:"
        plaTag = "Utgivelsested:"
        isbnTag = ">ISBN"
        pagesTag = "Format:"
        langTag = "Sprk:"
        deweyTag = "Dewey:"
        keywordsTag = "Emner:"
        descTag = "Beskrivelse:"


    # Find Title
    source = searchForPlus(source, titleTag)
    source = searchForPlus(source, "class=\"EXLLinkedFieldTitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.find(title, " / ")

    if i != -1:
        title = stripText(title[0:i])

    title = string.replace(title, "\n", " ")
    rw.setTitle(title)


    # Find Series
    i = string.find(source, seriesTag)

    if i != -1:
        source = searchForPlus(source, seriesTag)
        source = searchForPlus(source, "<td ")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        series = stripText(source[0:i])
        rw.setSeries(series)


    # Find Author
    i = string.find(source, authorTag)
    authorList = []

    if i != -1:
        source = searchForPlus(source, authorTag)
        source = searchForPlus(source, " href=\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        author = stripText(source[0:i])

        i = string.rfind(author, " ")

        if i != -1:
            last = stripText(author[i:])
            j = string.find(last, "-")

            if j != -1:
                last = stripText(last[0:j])

                try:
                    int(last)
                    author = stripText(author[0:i])
                except ValueError:
                    last = ""


        authorList.append(author)

        rw.setAuthors(authorList)


    # Find Published date
    i = string.find(source, dateTag)

    if i != -1:
        date = searchForPlus(source, dateTag)
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        i = string.find(date, "c")

        if i != -1:
            date = stripText(date[i+1:])
            copyDate = date
            rw.setCopyrightDate(copyDate)

        rw.setReleaseDate(date)


    # Find publisher
    i = string.find(source, pubTag)

    if i != -1:
        publisher = searchForPlus(source, pubTag)
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find publication place
    i = string.find(source, plaTag)

    if i != -1:
        place = searchForPlus(source, plaTag)
        place = searchForPlus(place, "\">")
        i = string.find(place, "<")
        place = stripText(place[0:i])
        rw.setPublicationPlace(place)


    # Find language
    i = string.find(source, langTag)

    if i != -1:
        language = searchForPlus(source, langTag)
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        language = stripText(language[0:i])

        i = string.find(language, " ")

        if i != -1:
            language = stripText(language[0:i])

        rw.setLanguage(language)


    # Find ISBN
    i = string.find(source, isbnTag)

    if i != -1:
        isbn = searchForPlus(source, isbnTag)
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Dewey
    i = string.find(source, deweyTag)

    if i != -1:
        dewey = searchForPlus(source, deweyTag)
        dewey = searchForPlus(dewey, "\">")
        i = string.find(dewey, "<")
        dewey = stripText(dewey[0:i])

        i = string.find(dewey, "[")

        if i != -1:
            dewey = stripText(dewey[0:i])

        i = string.find(dewey, " ")

        if i != -1:
            dewey = stripText(dewey[0:i])

        rw.setDewey(dewey)


    # Find pages
    i = string.find(source, pagesTag)

    if i != -1:
        pages = searchForPlus(source, pagesTag)
        pages = searchForPlus(pages, "\">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])

        while (string.find(pages, " ") != -1):
            i = string.find(pages, " ")

            try:
                int(pages[0:i])
                pages = stripText(pages[0:i])
            except:
                pages = stripText(pages[i+1:])

        rw.setPages(pages)


    # Find keywords
    i = string.find(source, keywordsTag)

    if i != -1:
        keywords = ""
        subjects = searchForPlus(source, keywordsTag)
        i = string.find(subjects, "<strong>")
        subjects = stripText(subjects[0:i])

        while (searchFor(subjects, "href=\"") != None):
            subjects = searchForPlus(subjects, "href=\"")
            subjects = searchForPlus(subjects, ">")
            i = string.find(subjects, "<")
            subject = stripText(subjects[0:i])

            if keywords != "":
                keywords = keywords + ", " + subject
            else:
                keywords = subject

        rw.setKeywords(keywords)


    # Find description
    i = string.find(source, descTag)

    if i != -1:
        desc = searchForPlus(source, descTag)
        desc = searchForPlus(desc, ">")
        i = string.find(desc, "</li>")
        desc = stripText(desc[0:i])
        rw.setProductInfo(desc)



try:
    rw.setBookObject(Book)

    i = string.find(source, ">Textbook Details<")

    if i == -1:
        extract(source)
    else:
        extractTextbook(source)

finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
