# bol.it scraper
#
# copied from various sources
#

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("Italia")
    rw.setLanguage("Italian")
    rw.setCurrencySymbol("")
   
    # is this the search page or the detail page?
    i = string.find (source, "ERROR - URL:")

    if i != -1: 
        source = searchForPlus(source, "ERROR - URL:")
        i = string.find(source, "/ea")
        url = stripText(source[0:i+3])
        source = searchForPlus(source, "/ea")
        i = string.find(source, ".")
        ean = "978" + stripText(source[0:i-1])

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url + ean + ".html")
        t = open(rw.getLogsDir() + "trace2.html", "w")
        t.write(source)
        t.close()

    uri = "http://www.bol.it"


    # Find Cover Image
    tag = "class=\"bol_cover\""
    i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "img src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        if (image[0] == "/"):
            image = uri + image;

        rw.setImage1(image)
 

    # Find Title
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "</h1>");
    title = stripText(source[0:i])
    rw.setTitle(title)
    source = stripText(source[i:])

    # Find Author
    # author is in an href tag, comma separated authors
    authorList = []

    i = string.find(source, "/libri/autore/")

    if i != -1:
        authors = searchForPlus(source, "/libri/autore/")
        authors = searchForPlus(authors, ">")
        i = string.find(authors, "<")
        authors = stripText(authors[0:i])

        while (authors != None):
            i = string.find(authors, ",")

            if i == -1:
                authorList.append(authors)
                authors = None
            else:
                authorList.append(authors[0:i])
                authors = stripText(authors[i+1:])                

        rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "Prezzo di copertina:")

    if i != -1:
        listprice = searchForPlus(source, "Prezzo di copertina:")
        listprice = searchFor(listprice, "&euro;")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find Price
    i = string.find(source, "Prezzo di copertina:")

    if i != -1:
        value = searchForPlus(source, "Prezzo di copertina:")
        value = searchFor(value, "&euro;")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(source, "class=\"bol_price\"")

        if i != -1:
            value = searchForPlus(source, "class=\"bol_price\"")
            value = searchFor(value, "&euro;")
            i = string.find(value, "<")
            value = stripText(value[0:i])

        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Comments
    i = string.find(source, "id=\"contenuto_scheda\"")

    if i != -1:
        comments = searchForPlus(source, "id=\"contenuto_scheda\"")
        comments = searchForPlus(comments, "<h3")
        comments = searchForPlus(comments, "\">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        rw.setProductInfo(comments)


    # Find Format
    i = string.find(source, ">Formato:<")

    if i != -1:
        format = searchForPlus(source, ">Formato:<")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find pages
    i = string.find(source, ">Pagine:<")

    if i != -1:
        pages = searchForPlus(source, ">Pagine:<")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find publisher
    i = string.find(source, ">Editore:<")

    if i != -1:
        publisher = searchForPlus(source, ">Editore:<")
        publisher = searchForPlus(publisher, "href=")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find publication date
    i = string.find(source, ">Anno di pubblicazione<")

    if i != -1:
        date = searchForPlus(source, ">Anno di pubblicazione<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find language
    i = string.find(source, ">Lingua:<")

    if i != -1:
        language = searchForPlus(source, ">Lingua:<")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        language = stripText(language[0:i])
        rw.setLanguage(language)


    # Find translator
    i = string.find(source, ">Traduttore:<")

    if i != -1:
        translator = searchForPlus(source, ">Traduttore:<")
        translator = searchForPlus(translator, "href=")
        translator = searchForPlus(translator, ">")
        i = string.find(translator, "<")
        translator = stripText(translator[0:i])
        rw.setTranslator(translator)


    # Find original title
    i = string.find(source, ">Titolo originale:<")

    if i != -1:
        title = searchForPlus(source, ">Titolo originale:<")
        title = searchForPlus(title, ">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        rw.setSubtitle(title)


    # Find ISBN
    i = string.find(source, ">Codice EAN:<")

    if i != -1:
        isbn = searchForPlus(source, ">Codice EAN:<")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Category
    i = string.find(source, ">Generi:<")

    if i != -1:
        category = ""
        categories = searchForPlus(source, ">Generi:<")
        i = string.find(categories, "</p>")
        categories = stripText(categories[0:i])
        ccount = 1

        while (string.find(categories, "class=\"bol_blue\"") != -1):
            categories = searchForPlus(categories, "class=\"bol_blue\"")
            categories = searchForPlus(categories, ">")
            i = string.find(categories, "<")
            category = stripText(categories[0:i])

            if ccount == 1:
                rw.setCategory1(category)
            elif ccount == 2:
                rw.setCategory2(category)
            else:
                rw.setCategory3(category)
                break

            ccount = ccount + 1

try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
