# amazon.com scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string
import  time

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date



def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setFormat("Hardcover")
    rw.setPublisher("The Folio Society")


    # Find Image
    i = string.find(source, "property=\"og:image\"")

    if i != -1:
        image = searchForPlus(source, "property=\"og:image\"")
        image = searchForPlus(image, "content=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            rw.setImage1(image)


    # Main extraction
    source = searchForPlus(source, "class=\"product-info-main\"")


    # Find Title
    title = searchForPlus(source, "class=\"page-title-wrapper product\"")
    title = searchForPlus(title, "<h1")
    title = searchForPlus(title, "itemprop=\"name\"")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    rw.setTitle(title)


    # Find Author
    i = string.find(source, "class=\"product-item-details-author\"")

    if i != -1:
        author = searchForPlus(source, "class=\"product-item-details-author\"")
        author = searchForPlus(author, "<span>")
        i = string.find(author, "<")
        author = stripText(author[0:i])
        rw.setAuthor(author)


    # Find Illustrator
    i = string.find(source, "class=\"product-item-details-illustrator\"")

    if i != -1:
        author = searchForPlus(source, "class=\"product-item-details-illustrator\"")
        author = searchForPlus(author, "<span>")
        i = string.find(author, "<")
        author = stripText(author[0:i])
        author = string.replace(author, "Illustrated by", "")


        rw.setIllustrator(author)


    # Find Price
    tag = "class=\"price\""
    i = string.find(source, tag)

    if i == -1:
        tag = ">Published price:"
        i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Attributes
    attr = ""
    tag = ">Production Details<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Production details<"
        i = string.find(source, tag)

    if i != -1:
        attr = searchForPlus(source, tag)
        attr = searchForPlus(attr, ">")
        i = string.find(attr, "</div>")
        attr = stripText(attr[0:i])

        # Find pages
        i = string.find(attr, " pages")

        if i != -1:
            pages = stripText(attr[i-8:])
            i = string.find(pages, " pages")
            pages = stripText(pages[0:i])
            i = string.find(pages, ">") 

            if i != -1:
                pages = searchForPlus(pages, ">")

            i = string.find(pages, " ") 

            if i != -1:
                pages = searchForPlus(pages, " ")

            i = string.find(pages, ".") 

            if i != -1:
                pages = searchForPlus(pages, ".")

            rw.setPages(pages)

        # Find dimensions
        i = string.find(attr, "size:")

        if i != -1:
            dimensions = stripText(attr[i+5:])
            i = string.find(dimensions, "<") 

            if i != -1:
                dimensions = stripText(dimensions[0:i])

            i = string.find(dimensions, ",") 

            if i != -1:
                dimensions = stripText(dimensions[0:i])

            i = string.find(dimensions, ".") 

            if i != -1:
                dimensions = stripText(dimensions[0:i])

            dimensions = string.replace(dimensions, "\xC3\x97", "x")
            dimensions = string.replace(dimensions, "\xC2\xBC", " 3/4")
            dimensions = string.replace(dimensions, "\xC2\xBD", " 1/2")
            dimensions = string.replace(dimensions, "\xC2\xBE", " 1/4")

            rw.setDimensions(dimensions)

        # Find publication date
        i = string.find(attr, "Publication date:")

        if i != -1:
            date = searchForPlus(attr, "Publication date:")
            i = string.find(date, ",") 

            if i != -1:
                date = stripText(date[0:i])

            i = string.find(date, ".") 

            if i != -1:
                date = stripText(date[0:i])

            i = string.find(date, "<") 

            if i != -1:
                date = stripText(date[0:i])

            rw.setReleaseDate(date)


    # Find Comments
    i = string.find(source, "class=\"short-description\"")

    if i != -1:
        comments = searchForPlus(source, "class=\"short-description\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = comments[0:i]

        if attr != "":
            comments = comments + "</p>" + attr

        comments = string.replace(comments, "<section>", "")
        comments = string.replace(comments, "</section>", "")
        comments = string.replace(comments, "<div class=\"quote\">", "<BR><BR>")
        comments = string.replace(comments, "<div class=\"quoter\">", " - ")
        comments = string.replace(comments, "\xE2\x80\x98", "'")
        comments = string.replace(comments, "\xE2\x80\x99", "'")
        comments = string.replace(comments, "\xC3\x97", "x")
        comments = string.replace(comments, "\xC2\xBC", " 3/4")
        comments = string.replace(comments, "\xC2\xBD", " 1/2")
        comments = string.replace(comments, "\xC2\xBE", " 1/4")
        rw.setProductInfo(comments)





try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
