# Good Reads book scraper
#
# Copyright  1999-2015 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")




    # Main extraction
    # Find Image
    i = string.find(source, "id=\"coverImage\"")

    if i != -1:
        image = searchForPlus(source, "id=\"coverImage\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "0000000000")

        if i != -1:
            image = ""

        rw.setImage1(image)

    i = string.find(source, "class=\"editionCover\"")

    if i != -1:
        image = searchForPlus(source, "class=\"editionCover\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "0000000000")

        if i != -1:
            image = ""

        rw.setLargeImage1(image)



    # Find Title
    source = searchForPlus(source, "id=\"bookTitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    rw.setTitle(title)


    # Find Series
    i = string.find(source, "/series/")

    if i != -1 and i < 500:
        series = searchForPlus(source, "/series/")
        series = searchForPlus(series, "(")
        i = string.find(series, ")")
        series = stripText(series[0:i])

        i = string.find(series, " #")

        if i != -1:
            rw.setSeriesNumber(stripText(series[i+2:]))
            series = stripText(series[0:i])

        rw.setSeries(series)


    # Find Author
    authorList = []
    i = string.find(source, "id=\"bookAuthors\"")

    if i != -1:
        source = searchForPlus(source, "id=\"bookAuthors\"")
        i = string.find(source, "</div>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "href=\"") != None):
            authors = searchForPlus(authors, "href=\"")
            authors = searchForPlus(authors, "itemprop=\"name\"")
            authors = searchForPlus(authors, ">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authors = searchForPlus(authors, "</a>")
            authors = stripText(authors)
            i = string.rfind(author, "(")

            if i != -1:
                role = stripText(author[i:])
                author = stripText(author[0:i])
                i = string.find(role, ")")
                role = stripText(role[0:i+1])

                if role == "(Illustrator)":
                    rw.setIllustrator(author)
                    author = ""
                elif role == "(Translator)":
                    rw.setTranslator(author)
                    author = ""
                elif role == "(Editor)":
                    rw.setEditor(author)
                    author = ""
                else:
                    author = author + " " + role
                
            if author != "":
                authorList.append(author)

    rw.setAuthors(authorList)


    # Find Rating
    i = string.find(source, "itemprop=\"ratingValue\"")

    if i != -1:
        rating = searchForPlus(source, "itemprop=\"ratingValue\"")
        rating = searchForPlus(rating, ">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])
        rw.setMyRating(rating)


    # Find Book Info
    i = string.find(source, "id=\"description\"")

    if i != -1:
        info = searchForPlus(source, "id=\"description\"")
        i = string.find(info, "id=\"freeTextContainer")

        if i != -1:
            info = searchForPlus(info, "id=\"")
            i = string.find(info, "\"")
            did = stripText(info[0:i])
            did = string.replace(did, "Container", "")
            i = string.find(info, did)

            if i != -1:
                info = searchForPlus(info, did)

            info = searchForPlus(info, ">")
            i = string.find(info, "</span>")
            info = stripText(info[0:i])
            info = string.replace(info, "\xC2\xA0", " ")
            info = string.replace(info, "\xC3\xA2", "")
            rw.setProductInfo(info)


    # Find Format
    i = string.find(source, "itemprop=\"bookFormatType\"")

    if i != -1:
        format = searchForPlus(source, "itemprop=\"bookFormatType\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find Pages
    i = string.find(source, "itemprop=\"numberOfPages\"")

    if i != -1:
        pages = searchForPlus(source, "itemprop=\"numberOfPages\"")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, " ")
        rw.setPages(stripText(pages[0:i]))


    # Find Publication date and publisher
    i = string.find(source, "id=\"details\"")

    if i != -1:
        publ = searchForPlus(source, "id=\"details\"")
        publ = searchForPlus(publ, "class=\"row\"")

        i = string.find(publ, "class=\"row\"")

        if i != -1:
            publ = searchForPlus(publ, "class=\"row\"")
            i = string.find(publ, "</div>")
            publ = stripText(publ[0:i])

            i = string.find(publ, "Published")

            if i != -1:
                publ = searchForPlus(publ, "Published")
                publ = searchForPlus(publ, "\n")
                i = string.find(publ, "\n")
                date = stripText(publ[0:i])
                date = string.replace(date, "th ", " ")
                date = string.replace(date, "st ", " ")
                date = string.replace(date, "nd ", " ")
                date = string.replace(date, "rd ", " ")

                rw.setReleaseDate(date)

            i = string.find(publ, "by ")

            if i != -1:
                publ = searchForPlus(publ, "by ")
                i = string.find(publ, "<")
                rw.setPublisher(stripText(publ[0:i]))

            i = string.find(publ, "(first published ")

            if i != -1:
                publ = searchForPlus(publ, "(first published ")
                i = string.find(publ, ")")
                rw.setCopyrightDate(stripText(publ[0:i]))


    # ISBN
    i = string.find(source, ">ISBN<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN<")
        isbn = searchForPlus(isbn, "\">")
        i = string.find(isbn, "<")
        rw.setISBN(stripText(isbn[0:i]))


    # Language
    i = string.find(source, ">edition language<")

    if i != -1:
        lang = searchForPlus(source, ">edition language<")
        lang = searchForPlus(lang, "'>")
        i = string.find(lang, "<")
        rw.setLanguage(stripText(lang[0:i]))


    # Find Category
    i = string.find(source, ">Genres<")

    if i != -1:
        cats = searchForPlus(source, ">Genres<")
        i = string.find(cats, "<span")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "class=\"elementList") != None):
            cats = searchForPlus(cats, "class=\"elementList")
            i = string.find(cats, "class=\"right\"")
            cat = stripText(cats[0:i])
            c = ""

            while (searchFor(cat, "href=\"") != None):
                cat = searchForPlus(cat, "href=\"")
                cat = searchForPlus(cat, ">")
                i = string.find(cat, "<")

                if c == "":
                    c = stripText(cat[0:i])
                else:
                    c = c + " > " + stripText(cat[0:i])

            if ccount == 1:
                rw.setCategory1(c)
            elif ccount == 2:
                rw.setCategory2(c)
            else:
                rw.setCategory3(c)
                break

            ccount = ccount + 1


    # Find Keywords
    i = string.find(source, ">Genres<")

    if i != -1:
        cats = searchForPlus(source, ">Genres<")
        i = string.find(cats, "<span")
        cats = stripText(cats[0:i])
        keys = ""

        while (searchFor(cats, "class=\"elementList") != None):
            cats = searchForPlus(cats, "class=\"elementList")
            i = string.find(cats, "class=\"right\"")
            cat = stripText(cats[0:i])

            while (searchFor(cat, "href=\"") != None):
                cat = searchForPlus(cat, "href=\"")
                cat = searchForPlus(cat, ">")
                i = string.find(cat, "<")
                c = stripText(cat[0:i])

                i = string.find(keys, c)

                if i == -1:
                    if keys == "":
                        keys = c
                    else:
                        keys = keys + ", " + c

        rw.setKeywords(keys)



try:
    rw.setBookObject(Book)
    extract(source)

finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
