# Chapters [CA] video scraper
#
# Copyright  1999-2007 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 1")
    vw.setCurrencySymbol("$")


    # Find Image
    i = string.find(source, "class=\"itemImageShow\"")

    if i != -1:
        image = searchForPlus(source, "class=\"itemImageShow\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if string.find(image, "NotAvailable") == -1:
            vw.setImage1(image)


    # Find Title
    i = string.find(source, "id=\"itemMainContent\"")

    if i != -1:
        source = searchForPlus(source, "id=\"itemMainContent\"")
        source = searchForPlus(source, "<h1>")
        i = string.find(source, "<")
        title = stripText(source[0:i])

        i = string.rfind(title, "(")

        if i != -1:
            title = stripText(title[0:i])

        vw.setTitle(title)


    # Find Actors
    actorTag = "Starring:"
    i = string.find(source, actorTag)

    if i != -1:
        source = searchForPlus(source, actorTag)
        i = string.find(source, "</p>")
        actors = stripText(source[0:i])

        i = string.find(actors, "<br/>")

        if i != -1:
            actors = stripText(actors[0:i])

        i = string.find(actors, "<span>")

        if i != -1:
            actors = stripText(actors[0:i])

        while (searchFor(actors, "<a href") != None):
            actors = searchForPlus(actors, "<a href")
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])
            vw.setActor(actor)


    # Find Director
    i = string.find(source, ">Director:")

    if i != -1:
        source = searchForPlus(source, ">Director:")
        source = searchForPlus(source, "<a href")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        director = stripText(source[0:i])
        vw.setDirector(director)


    # Find Format
    i = string.find(source, "class=\"product-specs\">")

    if i != -1:
        details = searchForPlus(source, "class=\"product-specs\">")
        i = string.find(details, "</p>")
        details = stripText(details[0:i])

        i = string.find(details, "DVD")

        if i != -1:
            vw.setFormat("DVD")


    # Find Comments
    comments = ""

    while (searchFor(source, "class=\"prod-desc\"") != None):
        source = searchForPlus(source, "class=\"prod-desc\"")
        source = searchForPlus(source, "\">")
        i = string.find(source, "</div>")
        comment = stripText(source[0:i])
        comments = appendComment(comments, comment)

    vw.setProductInfo(comments)


    # Find List price
    tag = ">List Price"
    i = string.find(source, tag)

    if i != -1:
        listprice = searchForPlus(source, tag)
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        vw.setListPrice(listprice)


    # Find Price
    tag = ">Our Price"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Online Price"
        i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Release date
    i = string.find(source, ">Video Release:")

    if i != -1:
        source = searchForPlus(source, ">Video Release:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        date = stripText(source[0:i])
        vw.setReleaseDate(date)


    # Find Copyright date
    i = string.find(source, "Theatrical Release:")

    if i != -1:
        source = searchForPlus(source, "Theatrical Release:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        copyDate = stripText(source[0:i])
        vw.setCopyrightDate(copyDate)


    # Find Runtime
    i = string.find(source, "Runtime:")

    if i != -1:
        source = searchForPlus(source, "Runtime:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        running = stripText(source[0:i])
        vw.setRunningTime(running)


    # Find Rating
    i = string.find(source, "Rating:")

    if i != -1:
        mpaa = searchForPlus(source, "Rating:")
        mpaa = searchForPlus(mpaa, ">")
        i = string.find(mpaa, "<")
        mpaa = stripText(mpaa[0:i])
        vw.setCertification(mpaa)


    # Find Studio
    i = string.find(source, "Studio:")

    if i != -1:
        source = searchForPlus(source, "Studio:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        studio = stripText(source[0:i])
        vw.setStudio(studio)


    # Find UPC
    i = string.find(source, "UPC:")

    if i != -1:
        source = searchForPlus(source, "UPC:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        upc = stripText(source[0:i])
        vw.setUPC(upc)






try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
