# half.com video scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setCurrencySymbol("$")

    i = string.find(source, "Search Results</B>")

    if i != -1:
        source = searchForPlus(source, "Search Results</B>")
        source = searchForPlus(source, "<A HREF=")

        # URL delimiter is somtimes single quote, sometimes
        # double quote, so use what is there
        i = string.find(source[1:], source[0:1])
        source = source[1:]
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find List price
    i = string.find(source, "List Price:")

    if i != -1:
        listprice = searchForPlus(source, "List Price:")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])

        i = string.find(listprice, "(")

        if (i != -1):
            listprice = stripText(listprice[0:i])

        vw.setListPrice(listprice)


    # Find New price
    i = string.find(source, "header_items_brandNew.gif")

    if (i != -1):
        try:
            newprice = searchForPlus(source, "header_items_brandNew.gif")
            newprice = searchForPlus(newprice, "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\">")
            i = string.find(newprice, "</table>")
            newprice = stripText(newprice[0:i])
            newprice = searchFor(newprice, "$")
            
            i = string.find(newprice, "<")
            
            if i != -1:
                newprice = stripText(newprice[0:i])

            vw.setNewPrice(newprice)
        except:
            newprice = ""


    # Find Used price
    i = string.find(source, "header_items_likeNew.gif")

    if i != -1:
        try:
            usedprice = searchForPlus(source, "header_items_likeNew.gif")
            usedprice = searchForPlus(usedprice, "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\">")
            i = string.find(usedprice, "</table>")
            usedprice = stripText(usedprice[0:i])
            usedprice = searchFor(usedprice, "$")
            
            i = string.find(usedprice, "<")
            
            if (i != -1):
                usedprice = stripText(usedprice[0:i])

            vw.setUsedPrice(usedprice)
        except:
            usedprice = ""


    # Main extraction
    # Find Image
    i = string.find(source, "class=\"pdpbg\"")

    if i != -1:
        source = searchForPlus(source, "class=\"pdpbg\"")
        i = string.find(source, ".ebayimg.")
        source = stripText(source[i-50:])
        source = searchForPlus(source, "<img src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        i = string.find(image, "593229")

        if i == -1:
            vw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"pdppagetitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    vw.setTitle(stripText(source[0:i]))


    # Find Price
    i = string.find(source, "class=\"beststyle\"")

    if i != -1:
        source = searchForPlus(source, "class=\"beststyle\"")
        source = searchFor(source, "$")
        i = string.find(source, "<")
        vw.setItemValue(stripText(source[0:i]))
        vw.setUsedPrice(stripText(source[0:i]))

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        vw.setFormat(stripText(format[0:i]))


    # Find Publication Date
    i = string.find(source, ">Format:<")

    if i != -1:
        source = searchForPlus(source, ">Format:<")
        if string.find(source, "</span><br><span class=\"\">") < string.find(source, "Rated"):
            date = searchForPlus(source, "</span><br><span class=\"\">")
            i = string.find(date, "<")
            date = stripText(date[0:i])

            if date.startswith("Rated") == 1:
                date = ""

            if date != "":
                vw.setReleaseDate(date)


    # Find Rating
    i = string.find(source, ">Rated ")

    if (i != -1):
        mpaa = searchForPlus(source, ">Rated ")
        i = string.find(mpaa, "<")
        vw.setCertification(stripText(mpaa[0:i]))


    # Find UPC
    i = string.find(source, ">UPC:<")

    if i != -1:
        attr = stripText(source[0:i])
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, "\">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        upc = string.replace(upc, "-", "")
        vw.setUPC(upc)


        # Find Color
        i = string.find(attr, ">Color")

        if i != -1:
            vw.setColor("Color")
        else:
            vw.setColor("B&W")


        # Find Captioning
        i = string.find(attr, " Closed Captioned")

        if i != -1:
            vw.setClosedCaptioned("true")
        else:
            vw.setClosedCaptioned("false")


        # Find Running time
        i = string.find(attr, " min.")

        if i != -1:
            running = attr[i-10:]
            running = searchForPlus(running, ">")
            i = string.find(running, "<")
            vw.setRunningTime(stripText(running[0:i]))


    # Find Comments
    comments = ""
    i = string.find(source, ">Movie Description<")

    if i != -1:
        comment = searchForPlus(source, ">Movie Description<")
        comment = searchForPlus(comment, "class=\"br\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<table ")
        comments = stripText(comment[0:i])

        i = string.find(comments, "</td>")

        if i != -1:
            comments = stripText(comments[0:i])

    i = string.find(source, "<b>Industry Reviews<")

    if i != -1:
        comment = searchFor(source, "<b>Industry Reviews<")
        comment = searchForPlus(comment, "<b>")
        i = string.find(comment, "<br class=\"br\"/><br class=\"br\"/>")
        comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    if comments != "":
        vw.setProductInfo(comments)


    # Find Actors
    i = string.find(source, ">Cast:<")

    if (i != -1):
        source = searchForPlus(source, ">Cast:<")
        source = searchForPlus(source, "\">")
        i = string.find(source, "</td>")
        actors = source[0:i]

        while (searchFor(actors, "href=") != None):
            actors = searchForPlus(actors, "href=")
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])

            vw.setActor(actor)


    # Find Director
    i = string.find(source, ">Director:<")

    if (i != -1):
        source = searchForPlus(source, ">Director:<")
        source = searchForPlus(source, "\">")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        vw.setDirector(stripText(source[0:i]))


    # Find Director
    i = string.find(source, ">Producer:")

    if (i != -1):
        source = searchForPlus(source, ">Producer:")
        source = searchForPlus(source, "\">")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        vw.setProducer(stripText(source[0:i]))


    # Find Widescreen
    i = string.find(source, ">Widescreen<")

    if i != -1:
        setAspectRatio("Widescreen")


    # Find Sound
    i = string.find(source, ">Audio:<")

    if (i != -1):
        sound = searchForPlus(source, ">Audio:<")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        vw.setSound(stripText(sound[0:i]))



try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
